<?php
/**
 * Template
 * Copyright (C) 2008 Saulo Popov Zambiasi
 *
 * Template is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Template is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: saulopz@gmail.com
*/

class Template {
	private $name;
	private $content;

	function Template($content, $name) {
		$this->name = $name;
		$this->content = $this->getContent($content);
	}
	
	private function getContent($content) {
		$begin = "<!--tpl:".$this->name."-->";
		$end   = "<!--/tpl:".$this->name."-->";
		$posBegin = stripos($content, $begin) + strlen($end) - 1;
		$posEnd = stripos($content, $end);
		return substr($content, $posBegin, $posEnd - $posBegin);
	}

	function assignVar($name, $value) {
		$tmp = str_ireplace ("{".$name."}", $value, $this->content);
		$this->content = $tmp;
	}

	function assignTemplate($templateName, $content) {
		$begin = "<!--tpl:".$templateName."-->";
		$end   = "<!--/tpl:".$templateName."-->";	
		$posBegin = stripos($this->content, $begin) - 1;
		$posEnd   = stripos($this->content, $end) + strlen($begin) + 1;
		
		$tmp = substr($this->content, 0, $posBegin);
		$tmp .= $content;
		$tmp .= substr($this->content, $posEnd, strlen($this->content));
		$this->content = $tmp;
	}

	function get() {
		return $this->content;
	}

	function show() {
		echo $this->content;
	}
}

class FileTemplate {
	private $content;

	function FileTemplate($fileName) {
		$file = fopen ($fileName, "r");
		$this->content = fread($file, filesize($fileName));
		fclose ($file);
	}
	
	function get() {
		return $this->content;
	}
}

?>